/*
 * The contents of this file are subject to the Netscape Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Netscape Communications
 * Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation.  All Rights
 * Reserved.
 *
 * Contributor(s):
 *   EVM-Group <evm@s3.uni-essen.de>
 */


// **************************************************************************
// ************************** EVM Functions *********************************
// **************************************************************************
// +++ GETTING MAILS OUT OF MOZILLA +++
// * for English description please read functions' prologues
//
// evmGetMozillaMail				-->	holt sich die Mail aus Mozilla und
//										speichert sie in einem Objekt
// evmConvertPRTimeToStringK		--> konvertiert die PRTime in einen String
// evmConvertDateToStringK			--> konvertiert das PRDate in einen String
// evmConvertDateToTimeStamp(tm)	--> konvertiert das PRDate in einen Timestamp
// evmCheckManyMails				--> durchluft mehrere Mails und archiviert
//										sie
// evmCheckOneMail					--> archiviert genau eine Mail
//
// **************************************************************************
// Version 07.02.2004 (Kai Henning, Andr Grothues)
// **************************************************************************

  var selected = 1; // Which pane (folder pane - search pane is selected
  var errormeldung = ""; // global parameter filled in case saving failed
  var waitdialog;

  // *************************************************************************
  // function:		evmGetMozillaMail(W)
  // status:		finished
  // author:		Kai Henning, Andr Grothues
  // *************************************************************************
  // sets preferences etc the way we need it later for saving the mozilla mail
  // information into an object parameter - but only in case more than one mail
  // is selected, because we better call the function evmCheckOneMail in that
  // case to avoid the unnecessary searching through the whole mailbox
  function evmGetMozillaMail(W)
  {
  	evmInitConnection()
	try
	{
	  // *** if user is offline, we might also not have a database connection!
      if (!gOfflineManager) GetOfflineMgrService();
      if(!CheckOnline())
      {
        alert("You are not online,\nfunction is not available!");
        return;
      }
	  // *** checking how many mails are selected
      try
      {
        var numMessages = gDBView.numSelected;
      }
      catch(ex)
      {
        alert("Please select a mail which you want to move to the EVM!");
        return;
      }
      if(numMessages == 0) { alert("Please select a mail which you want to move to the EVM!"); return; }
	  if(evmGetAttachmentMailDir() == "evmAttachmentMailError") return;
	  waitdialog = evmShowWaitDialogue(650,350,200);
	  waitdialog.document.title = "Archiving Mails";
	  waitdialog.document.write ("<body bgcolor = '#909090'><font face='arial'>");
	  waitdialog.document.writeln ("<h4>Data are now being put into the Database</h4><h5>This may take up to a few minutes</h5><p><ul>");
      if(numMessages == 1) { evmCheckOneMail(0); return; }
	  // *** saving message IDs
      var messageMID = [];
      var indices = GetSelectedIndices(GetDBView());
      for(var i = 0; i < numMessages; i++)
      {
        messageMID[i] = messenger.messageServiceFromURI(GetDBView().getURIForViewIndex(indices[i])).messageURIToMsgHdr(GetDBView().getURIForViewIndex(indices[i])).messageId + ": " + messenger.messageServiceFromURI(GetDBView().getURIForViewIndex(indices[i])).messageURIToMsgHdr(GetDBView().getURIForViewIndex(indices[i])).mime2DecodedAuthor;
      }
	  var errormeldung = "Errors occured when trying to save the following mails... please try again:\n\n"; // berschrift der Errormeldung
      var messageArray = GetSelectedMessages();
	  // *** closing down MessagePane for speed reasons
      if(!IsThreadAndMessagePaneSplitterCollapsed())
      {
        messagepanegeoeffnet = true;
        MsgToggleMessagePane();
      }
      else
      {
        messagepanegeoeffnet = false;
      }
	  // *** setting mail headers to the extended view
      if(pref.getIntPref("mail.show_headers") == 2) extH = 2;
      else
      {
        extH = pref.getIntPref("mail.show_headers");
        pref.setIntPref("mail.show_headers",2);
      }
	  // *** remembering first and last message of mailbox and then start the journey
	  // *** and mark every mail individually step by step
      GoNextMessage(nsMsgNavigationType.lastMessage, true);
      var letzteMail = GetFirstSelectedMessage();
      GoNextMessage(nsMsgNavigationType.firstMessage, true);
      var aktuelleMail = GetFirstSelectedMessage();
      if (aktuelleMail == letzteMail) bonus = true;
      else bonus = false;
      var behandelt = 0;

      for(var i = 0; ((aktuelleMail != letzteMail || behandelt < numMessages) || bonus); i++) // NEU: ODER-Verknpfung
      {
        for(var j = 0; j < messageArray.length; j++)
        {
          if(aktuelleMail == messageArray[j])
          {
            behandelt = behandelt + 1;
            bonus = false;
		    // *** calling the function to save the actual message into an object parameter
		    evmCheckManyMails(0);
          }
        }
        GoNextMessage(nsMsgNavigationType.nextMessage, true);
	    if (behandelt == numMessages) GoNextMessage(nsMsgNavigationType.lastMessage, true); // damit die for-Schleife schneller abbricht!!! (wg ODER-Verknpfung)
        aktuelleMail = GetFirstSelectedMessage();
      }
	  // *** setting settings back as they used to be
      if (extH != 2) pref.setIntPref("mail.show_headers",extH);
      if(messagepanegeoeffnet) MsgToggleMessagePane();
      if (errormeldung != "Errors occured when trying to save the following mails... please try again:\n\n")
      {
        //alert(errormeldung); // Ausgabe des Fehlerstring (sofern Fehler vorhanden)
	    waitdialog.document.write ("</ul></p><br> " + errormeldung);
      }
	  else waitdialog.document.write ("</ul></p><br> Operation completed successfully");
      errormeldung = "";
      GoNextMessage(nsMsgNavigationType.firstMessage, true);
      MsgReload();
	  // *** opening xul-window
      window.openDialog('chrome://evm/content/evm.xul', '_blank', 'chrome,dialog=no');
	  waitdialog.focus;
    }
    catch(ex)
    {
      alert("EVM Error in function evmGetMozillaMail: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmConvertPRTimeToStringK(tm)
  // status:		finished
  // author:		Kai Henning / Yvonne Pioch
  // *************************************************************************
  // converts PRTime into an ISO-string
  function evmConvertPRTimeToStringK(tm)
  {
    var time = new Date();
    time.setTime(tm / 1000);
    time = time.getHours() + ":" + time.getMinutes() + ":" + time.getSeconds();
    return time;
  }


  // *************************************************************************
  // function:		evmConvertDateToStringK(tm)
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // converts PRDate into an ISO-string
  function evmConvertDateToStringK(tm)
  {
    var time = new Date();
    time.setTime(tm / 1000);
    var year, month, date;
    year = 1900 + time.getYear();
    month = time.getMonth() + 1;  // since js month is 0-11
    date = time.getDate();
    var dateStr;
    var sep = "-";
    dateStr = year + sep + month + sep + date;
    return dateStr;
  }


  // *************************************************************************
  // function:		evmCheckManyMails(m)
  // status:		finished
  // author:		Kai Henning / Andr Grothues
  // *************************************************************************
  // if many mails were selected, this function is called when exactly one mail
  // is selected at this very moment to save all information into the object
  // paramter
  function evmCheckManyMails(m)
  {
	try
	{
      var mail = [];
      MsgToggleMessagePane();
      MsgReload();
	  /*alert("The chosen mail '" + gDBView.hdrForFirstSelectedMessage.mime2DecodedSubject + "'\nfrom " + gDBView.hdrForFirstSelectedMessage.mime2DecodedAuthor + "\nto " + gDBView.hdrForFirstSelectedMessage.mime2DecodedRecipients + "\nis going to be saved in the EVM now!\n\nDepending on the size of the current mailbox, the following procedures might take a little while.");*/
	  var tempdialog = evmShowWaitDialogue(1,1,-200);
	  tempdialog.close();

      mail["messageid"]      = gDBView.hdrForFirstSelectedMessage.messageId;
      mail["Ktime"]		   = evmConvertPRTimeToStringK(gDBView.hdrForFirstSelectedMessage.date);
      mail["Kdate"]		   = evmConvertDateToStringK(gDBView.hdrForFirstSelectedMessage.date);
      mail["mURI"]           = gDBView.URIForFirstSelectedMessage;
      mail["fURI"]           = GetSelectedFolderURI();
      mail["sURI"]           = GetServer(GetSelectedFolderURI()).rootFolder.URI;
  	  mail["msgsize"]        = gDBView.hdrForFirstSelectedMessage.messageSize;
      mail["offlmsgsize"]    = gDBView.hdrForFirstSelectedMessage.offlineMessageSize
      mail["isRead"]         = gDBView.hdrForFirstSelectedMessage.isRead;
      mail["Charset"]        = gDBView.hdrForFirstSelectedMessage.Charset;
  	  mail["numAttachments"] = currentAttachments.length;

	  waitdialog.document.write ("<li>Now archiving Mail with subject <b>" + gDBView.hdrForFirstSelectedMessage.mime2DecodedSubject + "</b>");
	  waitdialog.focus;

      var errorchance = true;
  	  for (element in currentHeaderData)
      {
        mail[currentHeaderData[element].headerName.toLowerCase()] = currentHeaderData[element].headerValue;
    	if (currentHeaderData[element].headerValue == "<" + gDBView.hdrForFirstSelectedMessage.messageId + ">") errorchance = false; // NEU: die Variablen, die uns bisher Schwierigkeiten bereitet haben, werden verglichen
      }
      if (errorchance == true) errormeldung = errormeldung + gDBView.hdrForFirstSelectedMessage.mime2DecodedAuthor + " with '" + gDBView.hdrForFirstSelectedMessage.mime2DecodedSubject + "'\n\n";
      mail["body"]           = window.content.document.body.innerHTML;
      //MsgToggleMessagePane();
      if (mail["numAttachments"] > 0)
      {
        for(var index = 1; index <= mail["numAttachments"]; index++)
        {
          var attachment = currentAttachments[index-1];
          mail["evmA" + index + "displayName"] = attachment["displayName"];
          mail["evmA" + index + "contentType"] = attachment["displayName"];

        }
	    mail["trex"] = evmCreateAttachmentFile(mail["messageid"],evmGetFolderPathFromFolderURI(mail["fURI"]),evmGetMailboxpathFromServerURI(mail["sURI"]));
	    if(mail["trex"] == "evmTimestampError") mail["trex"] = evmConvertDateToTimeStamp(gDBView.hdrForFirstSelectedMessage.date);
      }

      else
      {
        mail["trex"] = evmGetTimestamp(mail["messageid"],evmGetFolderPathFromFolderURI(mail["fURI"]),evmGetMailboxpathFromServerURI(mail["sURI"]));
	    if(mail["trex"] == "evmTimestampError") mail["trex"] = evmConvertDateToTimeStamp(gDBView.hdrForFirstSelectedMessage.date);
      }
	  // *** inserting current mail into DB
      evmDoQuery(mail);
	}
    catch(ex)
    {
      alert("EVM Error in function evmCheckManyMails: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmCheckOneMail(m)
  // status:		finished
  // author:		Kai Henning / Andr Grothues
  // *************************************************************************
  // if only one mail was selected, this function can do all work by itself
  // cuz there is no need to make a walk through the whole mailbox to mark
  // each selected mail individually since there is only one mail selected
  // now anyways
  function evmCheckOneMail(m)
  {
	try
	{
	  // *** setting mail headers to the extended view
      if(pref.getIntPref("mail.show_headers") == 2) extH = 2;
      else
      {
        extH = pref.getIntPref("mail.show_headers");
        pref.setIntPref("mail.show_headers",2);
      }
	  // *** closing down MessagePane for speed reasons
      if(!IsThreadAndMessagePaneSplitterCollapsed())
      {
        messagepanegeoeffnet = true;
      }
      else
      {
        messagepanegeoeffnet = false;
        MsgToggleMessagePane();
      }
      MsgReload();
      var mail = {};
	  //alert("The chosen mail '" + gDBView.hdrForFirstSelectedMessage.mime2DecodedSubject + "'\nfrom " + gDBView.hdrForFirstSelectedMessage.mime2DecodedAuthor + "\nto " + gDBView.hdrForFirstSelectedMessage.mime2DecodedRecipients + "\nis going to be saved in the EVM now!\n\nDepending on the size of the current mailbox, the following procedures might take a little while.");
	  var tempdialog = evmShowWaitDialogue(1,1,-200);
	  tempdialog.close();

      mail["messageid"]      = gDBView.hdrForFirstSelectedMessage.messageId;
      mail["Ktime"]		   = evmConvertPRTimeToStringK(gDBView.hdrForFirstSelectedMessage.date);
      mail["Kdate"]		   = evmConvertDateToStringK(gDBView.hdrForFirstSelectedMessage.date);
      mail["mURI"]           = gDBView.URIForFirstSelectedMessage;
      mail["fURI"]           = GetSelectedFolderURI();
      mail["sURI"]           = GetServer(GetSelectedFolderURI()).rootFolder.URI;
      mail["msgsize"]        = gDBView.hdrForFirstSelectedMessage.messageSize;
      mail["offlmsgsize"]    = gDBView.hdrForFirstSelectedMessage.offlineMessageSize
      mail["isRead"]         = gDBView.hdrForFirstSelectedMessage.isRead;
      mail["Charset"]        = gDBView.hdrForFirstSelectedMessage.Charset;
      mail["numAttachments"] = currentAttachments.length;

	  waitdialog.document.write ("<li>Now archiving Mail with subject <b>" + gDBView.hdrForFirstSelectedMessage.mime2DecodedSubject + "</b>");
	  waitdialog.focus;

      var errorchance = true;
      for (element in currentHeaderData)
      {
        mail[currentHeaderData[element].headerName.toLowerCase()] = currentHeaderData[element].headerValue;
        if (currentHeaderData[element].headerValue == "<" + gDBView.hdrForFirstSelectedMessage.messageId + ">") errorchance = false; // NEU: die Variablen, die uns bisher Schwierigkeiten bereitet haben, werden verglichen
      }
      mail["body"]           = window.content.document.body.innerHTML;

      if (mail["numAttachments"] > 0)
      {
        for(var index = 1; index <= mail["numAttachments"]; index++)
        {
          var attachment = currentAttachments[index-1];
          mail["evmA" + index + "displayName"] = attachment["displayName"];
          mail["evmA" + index + "contentType"] = attachment["displayName"];

        }
	    mail["trex"] = evmCreateAttachmentFile(mail["messageid"],evmGetFolderPathFromFolderURI(mail["fURI"]),evmGetMailboxpathFromServerURI(mail["sURI"]));
	    if(mail["trex"] == "evmTimestampError") mail["trex"] = evmConvertDateToTimeStamp(gDBView.hdrForFirstSelectedMessage.date);
      }
      else
      {
	    mail["trex"] = evmGetTimestamp(mail["messageid"],evmGetFolderPathFromFolderURI(mail["fURI"]),evmGetMailboxpathFromServerURI(mail["sURI"]));
	    if(mail["trex"] == "evmTimestampError") mail["trex"] = evmConvertDateToTimeStamp(gDBView.hdrForFirstSelectedMessage.date);
      }
      if (errorchance == true) alert("Errors occured when trying to save the following mail... please try again:\n\n" + gDBView.hdrForFirstSelectedMessage.mime2DecodedAuthor + " with '" + gDBView.hdrForFirstSelectedMessage.mime2DecodedSubject + "'\n\n"); // Neu: Ausgabe der Fehlermeldung
	  // *** setting settings back as they used to be
      if (extH != 2) pref.setIntPref("mail.show_headers",extH);
      if(!messagepanegeoeffnet) MsgToggleMessagePane();
      MsgReload();
	  // *** inserting current mail into DB
      evmDoQuery(mail);
	  // *** opening xul-window
      window.openDialog('chrome://evm/content/evm.xul', '_blank', 'chrome,dialog=no');
    }
    catch(ex)
    {
      alert("EVM Error in function evmCheckOneMail: " + ex);
    }
  }

// **************************************************************************
// ********************** END of EVM Functions ******************************
// **************************************************************************